-- **************************************************************************
--   TitanClan.lua
--  
--   By: KanadiaN
--        (Lindarena@Laughing Skull)
-- **************************************************************************

local L = LibStub( "AceLocale-3.0" ):GetLocale( "Titan", true );
local LB = LibStub( "AceLocale-3.0" ):GetLocale( "TitanClan", true );

-- **************************************************************************
-- NAME : TitanClan_Init( state )
-- DESC : For first time addon use
-- **************************************************************************
function TitanClan_Init( state )
     if ( state == "checkDB" ) then
          checkDB = true;
          TitanClanInit = false;
     elseif ( state == "init" ) then
          checkDB = false;
     end
     if ( type( TitanClan ) ~= "table" ) then TitanClan = {}; end
     if ( TitanClanInit ~= true ) then
          if ( checkDB ) then TitanClan_DebugUtils( "Info", "checkDB", LB["TITAN_CLAN_MENU_CHECKDB"] ); end
	  if ( not TitanClanStaticArrays or TitanClanStaticArrays == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "checkDB", LB["TITAN_CLAN_STATICARRAY_FIXED1"]:format( "TitanClanStaticArrays" ) ); end
               TitanClanStaticArrays = {};
          end
	  if ( not TitanClanStaticArrays.presets or TitanClanStaticArrays.presets == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "checkDB", LB["TITAN_CLAN_STATICARRAY_FIXED2"]:format( "presets" ) ); end
               TitanClanStaticArrays.presets = {
                    LB["TITAN_CLAN_CONFIG_NONE"],
                    "!s (!l) !p ~ !z !c !r",
                    "!s (!l) !uc ~ !z !r",
               };
          end
	  if ( not TitanClanStaticArrays.sortTypes or TitanClanStaticArrays.sortTypes == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "checkDB", LB["TITAN_CLAN_STATICARRAY_FIXED2"]:format( "sortTypes" ) ); end
               TitanClanStaticArrays.sortTypes = {
                    -- This will need to localized
                    LB["TITAN_CLAN_CONFIG_NAME"], LB["TITAN_CLAN_CONFIG_ZONE"], LB["TITAN_CLAN_CONFIG_RANK"], LB["TITAN_CLAN_CONFIG_LEVEL"], LB["TITAN_CLAN_CONFIG_CLASS"],
               };
          end
	  if ( not TitanClanStaticArrays.Stream or TitanClanStaticArrays.Stream == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "checkDB", LB["TITAN_CLAN_STATICARRAY_FIXED2"]:format( "Stream" ) ); end
               TitanClanStaticArrays.Stream = {};
          end
          if ( not TitanClanStaticArrays.guildMenu ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "checkDB", LB["TITAN_CLAN_STATICARRAY_FIXED2"]:format( "guildMenu" ) ); end
               TitanClanStaticArrays.guildMenu = {};
          end
	  if ( not TitanClanLocals or TitanClanLocals == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "info", "checkDB", LB["TITAN_CLAN_ARRAY"]:format( "TitanClanLocals" ) ); end
               TitanClanLocals = {};
          end
	  if ( not TitanClanLocals.LocalClass or TitanClanLocals.LocalClass == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "info", "checkDB", LB["TITAN_CLAN_LOCALSARRAY_FIXED2"]:format( "LocalClass" ) ); end
               TitanClanLocals.LocalClass = {};
          end
	  if ( not TitanClanLocals.ColorClass or TitanClanLocals.ColorClass == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "info", "checkDB", LB["TITAN_CLAN_LOCALSARRAY_FIXED2"]:format( "ColorClass" ) ); end
               TitanClanLocals.ColorClass = {};
          end
	  if ( not TitanClanLocals.ToEnglish or TitanClanLocals.ToEnglish == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "info", "checkDB", LB["TITAN_CLAN_LOCALSARRAY_FIXED2"]:format( "ToEnglish" ) ); end
               TitanClanLocals.ToEnglish = {};
          end
          if ( not TitanClanDebug or TitanClanDebug == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "checkDB", LB["TITAN_CLAN_ARRAY"]:format( "TitanClanDebug" ) ); end
               TitanClanDebug = {
                    State = false,
                    Event = false,
                    LogEvent = false,
                    dLine = "",
                    FormatToRemove = LB["TITAN_CLAN_CONFIG_NONE"], 
                    Temp = {},
                    Log = {},
               };
          end
          if ( not TitanClan.AddAuth or TitanClan.AddAuth == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "checkDB", LB["TITAN_CLAN_ARRAY_FIXED"]:format( "AddAuth" ) ); end
               TitanClan.AddAuth = {};
          end
          if ( not TitanClan.Settings or TitanClan.Settings == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "checkDB", LB["TITAN_CLAN_ARRAY_FIXED"]:format( "Settings" ) ); end
               TitanClan.Settings = {
                    ShowMem = true,
                    DisplayB = true,
                    tFormat = "!s (!l) !uc ~ !z !r",
                    sFormat = ( "<%s>" ):format( LB["TITAN_CLAN_CONFIG_AWAY"] ),
                    sType = LB["TITAN_CLAN_CONFIG_NAME"],
                    maxTooltip = 30,
                    Version = LB["TITAN_CLAN_CORE_VERSION"],
                    ArrayVersion = LB["TITAN_CLAN_CORE_AVER"],
               };
          end
          TitanClanInit = true;
          if ( checkDB ) then TitanClan_DebugUtils( "Info", "checkDB", LB["TITAN_CLAN_MENU_CHECKDB_FINSIHED"] ); end
     end
     if ( not TitanClanProfile or TitanClanProfile == nil ) then
          TitanClanProfile = {};
     end
     TitanClanProfile = {
          Faction = LB["TITAN_CLAN_CONFIG_UNKNOWN"],
          Realm = LB["TITAN_CLAN_CONFIG_UNKNOWN"],
          Player = LB["TITAN_CLAN_CONFIG_UNKNOWN"],
     };
     TitanClan_CoreUtils( "getLocals" );
     TitanClan_CoreUtils( "setIcon" );
     TitanClanDebug.FormatToRemove = LB["TITAN_CLAN_CONFIG_NONE"];
end

-- **************************************************************************
-- NAME : TitanPanelClanButton_OnEvent()
-- DESC : Event Handler
-- **************************************************************************
function TitanPanelClanButton_OnEvent( self, event, ... )
     local arg1 = ...
     if ( event == "ADDON_LOADED" and arg1 == "TitanClan" ) then
          TitanClan_Init( "init" );
     elseif ( event == "PLAYER_ENTERING_WORLD" ) then
          if ( TitanClan.Settings.DisplayB ) then TitanClan_CoreUtils( "Banner" ); end
          TitanClan_SetUser();
     elseif ( event == "CHAT_MSG_SYSTEM" ) then
          local matchOnline = "^.*%[(.*)%].*" .. string.sub( ERR_FRIEND_ONLINE_SS, 20 );
          local matchOffline = string.format( ERR_FRIEND_OFFLINE_S, "(.*)" );
          if ( string.match( arg1, matchOnline ) or string.match( arg1, matchOffline ) ) then
               TitanPanelButton_UpdateButton( LB["TITAN_CLAN_CORE_ID"] );
               -- PlaySoundFile( "Sound\\Creature\\Sindragosa\\IC_Sindragosa_Slay01.wav" );
          end
     elseif ( event == "GUILD_ROSTER_UPDATE" ) then
          TitanClan_CoreUtils( "buildArrays" );
          TitanClan_CoreUtils( "setIcon" );
          TitanPanelButton_UpdateButton( LB["TITAN_CLAN_CORE_ID"] );
          TitanPanelButton_UpdateTooltip( self );
     end
end

-- **************************************************************************
-- NAME : TitanPanelClanButton_GetButtonText()
-- DESC : Build Button Text
-- **************************************************************************
function TitanPanelClanButton_GetButtonText()
     local buttonRichText, buttonRichLabel, numT, numO;
     if ( IsInGuild() ) then
          numT, numO = GetNumGuildMembers();
          numT = TitanClan_ColorUtils( "cText", "white", numT );
          numO = TitanClan_ColorUtils( "cText", "green", numO );
          buttonRichLabel = LB["TITAN_CLAN_BUTTON_LABEL"]:format( GetGuildInfo( "player" ) );
          buttonRichText = LB["TITAN_CLAN_BUTTON_TEXT"]:format( numO, numT );
     else
          buttonRichLabel = "";
          buttonRichText = LB["TITAN_CLAN_BUTTON_CLANLESS"];
     end
     return buttonRichLabel, buttonRichText;
end

-- **************************************************************************
-- NAME : TitanPanelClanButton_OnClick()
-- DESC : Toggles Friends Dialog
-- **************************************************************************
function TitanPanelClanButton_OnClick( self, button )
     if ( button == "LeftButton" ) then
          ToggleGuildFrame();
     else
          TitanPanelButton_OnClick( self, button );
     end
end

-- **************************************************************************
-- NAME : TitanClan_SetUser()
-- DESC : Sets up the User for use with the data array
-- **************************************************************************
function TitanClan_SetUser()
     local Faction = UnitFactionGroup( "player" );
     local Realm = GetCVar( "realmName" );
     local Player = GetUnitName( "player" );
     if ( not TitanClanProfile.Faction or TitanClanProfile.Faction ~= Faction ) then TitanClanProfile.Faction = Faction; end
     if ( not TitanClanProfile.Realm or TitanClanProfile.Realm ~= Realm ) then TitanClanProfile.Realm = Realm; end
     if ( not TitanClanProfile.Player or TitanClanProfile.Player ~= Player ) then TitanClanProfile.Player = Player; end
end